/* ************************************************************
 * WARNING
 **************************************************************
 *
 * If you want to add something in the exported functions
 * you ***MUST*** increase the XF_VERSION in exports.h
 * DO NOT CHANGE OR DELETE ANY ENTRY
 * Append new Entries at the end of the list
 *
 **************************************************************
 * WARNING
 **************************************************************/

#include <common.h>
#include <exports.h>

extern void env_relocate_spec (void);

static void dummy(void)
{
}

unsigned long get_version(void)
{
	return XF_VERSION;
}

void jumptable_init (void)
{
	DECLARE_GLOBAL_DATA_PTR;
	int i;

	gd->jt = (void **) malloc (XF_MAX * sizeof (void *));
	for (i = 0; i < XF_MAX; i++)
		gd->jt[i] = (void *) dummy;

	gd->jt[XF_get_version] = (void *) get_version;
	gd->jt[XF_malloc] = (void *) malloc;
	gd->jt[XF_free] = (void *) free;
	gd->jt[XF_get_timer] = (void *)get_timer;
	gd->jt[XF_udelay] = (void *)udelay;
	gd->jt[XF_memcpy] = (void *)memcpy;
	gd->jt[XF_memset] = (void *)memset;
	gd->jt[XF_strcpy] = (void *)strcpy;
	gd->jt[XF_strcat] = (void *)strcat;
	gd->jt[XF_strlen] = (void *)strlen;
	gd->jt[XF_sprintf] = (void *)sprintf;
	gd->jt[XF_strstr] = (void *)strstr;
	gd->jt[XF_strtok] = (void *)strtok;
	gd->jt[XF_strchr] = (void *)strchr;
	gd->jt[XF_run_command] = (void *)run_command;
	gd->jt[XF_vsprintf] = (void *)vsprintf;
	gd->jt[XF_do_reset] = (void *)do_reset;
	gd->jt[XF_ListCreate] = (void *)ListCreate;
	gd->jt[XF_ListGetPtrToItem] = (void *)ListGetPtrToItem;
	gd->jt[XF_ListNumItems] = (void *)ListNumItems;
	gd->jt[XF_ListInsertItem] = (void *)ListInsertItem;
	gd->jt[XF_ListRemoveItem] = (void *)ListRemoveItem;
	gd->jt[XF_device_register] = (void *)device_register;
	gd->jt[XF_devices_init] = (void *)devices_init;
	gd->jt[XF_console_assign] = (void *)console_assign;

#if (CONFIG_COMMANDS & CFG_CMD_JFFS2)
	gd->jt[XF_load_binary] = (void *)load_binary;
#else
	gd->jt[XF_load_binary] = (void *)dummy;
#endif

#ifndef CONFIG_TFTP_RESCUE
	gd->jt[XF_simple_strtol] = (void *)simple_strtol;
	gd->jt[XF_disable_ctrlc] = (void *)disable_ctrlc;
	gd->jt[XF_setenv] = (void *)setenv;
	gd->jt[XF_enable_interrupts] = (void *)enable_interrupts;
	gd->jt[XF_disable_interrupts] = (int *)disable_interrupts;
	gd->jt[XF_addr2info] = (void *)addr2info;
	gd->jt[XF_flash_perror] = (void *)flash_perror;
	gd->jt[XF_flash_protect] = (void *)flash_protect;
	gd->jt[XF_flash_write] = (void *)flash_write;
	gd->jt[XF_flash_erase] = (void *)flash_erase;
	gd->jt[XF_crc32] = (void *)crc32;
	gd->jt[XF_crc32_no_comp] = (void *)crc32_no_comp;
	gd->jt[XF_env_init] = (void *)env_init;
	gd->jt[XF_env_relocate_spec] = (void *)env_relocate_spec;
	gd->jt[XF_env_relocate] = (void *)env_relocate;
	gd->jt[XF_saveenv] = (void *)saveenv;
#endif
#ifdef CONFIG_USE_IRQ
	gd->jt[XF_install_hdlr] = (void *) irq_install_handler;
	gd->jt[XF_free_hdlr] = (void *) irq_free_handler;
#endif	/* CONFIG_USE_IRQ */
#if (CONFIG_COMMANDS & CFG_CMD_I2C)
	gd->jt[XF_i2c_write] = (void *) i2c_write;
	gd->jt[XF_i2c_read] = (void *) i2c_read;
#endif	/* CFG_CMD_I2C */
}

/* ************************************************************
 * WARNING
 **************************************************************
 *
 * If you want to add something in the exported functions
 * you ***MUST*** increase the XF_VERSION in exports.h
 * DO NOT CHANGE OR DELETE ANY ENTRY
 * Append new Entries at the end of the list
 *
 **************************************************************
 * WARNING
 **************************************************************/
