/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : daemon.c
** Branch      : \main
** Version     : 2
** 
** Copyright (C) 2004,2005 by Siemens AG
** All Rights Reserved
** 
**-USER-------------------------------------------------------------------------
**
** Author      : hannes.strauss@siemens.com
** Creation    : 15-Dez-04.16:57:43
**
** Description : ftp daemon
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   2 |050114|ritter     | fixed vfork daemon
**   1 |041215|strauss    | ftp daemon created
**   0 |041215|strauss    | no comment
** --- |041215|strauss    | branch \main for daemon.c created
**-END-+------+-----------+---------------------------------------------------*/
#define __CCVERSION__     "/main/2"
/*-
 * Copyright (c) 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <paths.h>
#include <unistd.h>
#include <errno.h>

#include "daemon.h"
#define  MAX_ARGS_COUNT     20

int vfork_daemon(int argc, char *argv[])
{
    int i;
    char *vfork_args[MAX_ARGS_COUNT + 2];

    argc = (argc > MAX_ARGS_COUNT) ? MAX_ARGS_COUNT : argc;
    // copy args and append '-x'
    for (i = 0; i < argc; ++i)
    {
        vfork_args[i] = argv[i];
    }
    // add custom arg to mark vfork called
    vfork_args[i++] = "-x";
    vfork_args[i++] = 0;

    switch (vfork())
    {
        case 0:
            /* child */
            /* Make certain we are not a session leader, or else we
             * might reacquire a controlling terminal */
            execv(vfork_args[0], vfork_args);
            fprintf(stderr, "vfork execv failed %s\n", strerror(errno));
            exit(-1);

        case -1: /* error */
            fprintf(stderr, "vfork: %s", strerror(errno));
            return -1;
    }
    return 0;
}

