
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <errno.h>
#include <signal.h>
#include "extern.h"

#define MAX_BUF_SIZE     255

void wimax_check_store(const char* dir_name, const char* file_name)
{
    char buf[MAX_BUF_SIZE + 1];
    __sighandler_t save_chld;
    FILE* outPipe;

	buf[0] = 0;
	snprintf(buf, MAX_BUF_SIZE, "/usr/bin/update.sh store %s %s | logger -p ftp.info 2>&1", dir_name, file_name);
    syslog(LOG_INFO, "run update script: %s", buf);

    save_chld = signal(SIGCHLD, SIG_DFL);
    outPipe = ftpd_popen(buf, "r");
    if (outPipe)
    {
        if (ftpd_pclose(outPipe) == -1)
        {
            syslog(LOG_WARNING, "Script returned error: %s", strerror(errno));
        }
	}
	else
	{
    	syslog(LOG_WARNING, "popen returned error: %s", strerror(errno));
    }
    signal(SIGCHLD, save_chld);
}
