/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : gpio.h
** Branch      : \main
** Version     : 14
** 
** Copyright (C) 2004,2005 by Siemens AG
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** 
**-USER-------------------------------------------------------------------------
**
** Author      : thomas.x.ritter@siemens.com
** Creation    : 08-Nov-04.16:03:40
**
** Description : please insert module description here
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**  14 |050831|ritter     | Added GPIO defines
**  12 |050818|ritter     | Added PL022 / SSP header
**  11 |050802|strauss    | [BL016] Kernel: Adaption for Shrink-Version
**     |      |           | [BL016] Kernel: Detect HW-Version, Bootmode and Timerclock before any driver is loaded
**  10 |050628|ritter     | Added GPL license comment
**   8 |050323|strauss    | get/set gpios from userspace
**     |      |           | use alive/load led only in development mode
**     |      |           | blink during bootup
**   7 |050211|strauss    | new gpios for watchdog
**   6 |050204|ritter     | Fix compiler warning
**   5 |050119|sueli      | GPIO-module 8 definitions added
**   4 |041222|strauss    | char device for gpio-events
**   3 |041217|strauss    | interrupt on gpio factory-reset change
**   2 |041207|strauss    | New LED-GPIO Mapping
**     |      |           | Works on CDP and CPP
**   1 |041108|ritter     |
**   0 |041108|ritter     | no comment
** --- |041108|ritter     | branch \main for gpio.h created
**-END-+------+-----------+---------------------------------------------------*/
#ifndef __ASM_ARM_ARCH_GPIO_H
#define __ASM_ARM_ARCH_GPIO_H

/*============================================================================*\
|  gpio.h - Register Definitions for the GPIO-Pins of 5116
\*============================================================================*/
#define PL061_BASE_0            0x101D1000  /* base address: PL061 GPIO [0] */
#define PL061_BASE_1            0x101D2000  /* base address: PL061 GPIO [1] */
#define PL061_BASE_2            0x101D3000  /* base address: PL061 GPIO [2] */
#define PL061_BASE_3            0x101D4000  /* base address: PL061 GPIO [3] */
#define PL061_BASE_4            0xB0020000  /* base address: PL061 GPIO [4] */
#define PL061_BASE_5            0xA4004000  /* base address: PL061 GPIO [5] */
#define PL061_BASE_6            0xA4005000  /* base address: PL061 GPIO [6] */
#define PL061_BASE_7            0xB0027000  /* base address: PL061 GPIO [7] */
#define PL061_BASE_8            0xB0028000  /* base address: PL061 GPIO [8] */

#define TMUX0_BASE             0xb0021000
#define TMUX1_BASE             0xb0022000
#define TMUX2_BASE             0xb0023000
#define TMUX3_BASE             0xb0024000
#define TMUX4_BASE             0xb0025000
#define TMUX5_BASE             0xa4006000
#define TMUX6_BASE             0xa4007000
#define TMUX7_BASE             0xa4008000
#define TMUX8_BASE             0x101d8000

#define GPIODATA(base, mask)            base+(mask << 2)
#define GPIODIR(base)		            (base+0x400)
#define GPIOAFSEL(base)		            (base+0x420)

/*GPIO-module 0*/
#define GPIODATA0(mask)                 PL061_BASE_0+(mask << 2)
#define GPIODIR0                        PL061_BASE_0+0x400
#define GPIOIS0                         PL061_BASE_0+0x404
#define GPIOIBE0                        PL061_BASE_0+0x408
#define GPIOIEV0                        PL061_BASE_0+0x40C
#define GPIOIE0                         PL061_BASE_0+0x410
#define GPIORIS0                        PL061_BASE_0+0x414
#define GPIOMIS0                        PL061_BASE_0+0x418
#define GPIOIC0                         PL061_BASE_0+0x41C
#define GPIOAF0                         PL061_BASE_0+0x420

/*GPIO-module 1*/
#define GPIODATA1(mask)                 PL061_BASE_1+(mask << 2)
#define GPIODIR1                        PL061_BASE_1+0x400
#define GPIOIS1                         PL061_BASE_1+0x404
#define GPIOIBE1                        PL061_BASE_1+0x408
#define GPIOIEV1                        PL061_BASE_1+0x40C
#define GPIOIE1                         PL061_BASE_1+0x410
#define GPIORIS1                        PL061_BASE_1+0x414
#define GPIOMIS1                        PL061_BASE_1+0x418
#define GPIOIC1                         PL061_BASE_1+0x41C
#define GPIOAF1                         PL061_BASE_1+0x420

/*GPIO-module 2*/
#define GPIODATA2(mask)                 PL061_BASE_2+(mask << 2)
#define GPIODIR2                        PL061_BASE_2+0x400
#define GPIOIS2                         PL061_BASE_2+0x404
#define GPIOIBE2                        PL061_BASE_2+0x408
#define GPIOIEV2                        PL061_BASE_2+0x40C
#define GPIOIE2                         PL061_BASE_2+0x410
#define GPIORIS2                        PL061_BASE_2+0x414
#define GPIOMIS2                        PL061_BASE_2+0x418
#define GPIOIC2                         PL061_BASE_2+0x41C
#define GPIOAF2                         PL061_BASE_2+0x420
#define GPIOPERIF2_ID1                  PL061_BASE_2+0xFE0
#define GPIOPERIF2_ID2                  PL061_BASE_2+0xFE4
#define GPIOPERIF2_ID3                  PL061_BASE_2+0xFE8
#define GPIOPERIF2_ID4                  PL061_BASE_2+0xFEC


/*GPIO-module 3*/
#define GPIODATA3(mask)                 PL061_BASE_3+(mask << 2)
#define GPIODIR3                        PL061_BASE_3+0x400
#define GPIOIS3                         PL061_BASE_3+0x404
#define GPIOIBE3                        PL061_BASE_3+0x408
#define GPIOIEV3                        PL061_BASE_3+0x40C
#define GPIOIE3                         PL061_BASE_3+0x410
#define GPIORIS3                        PL061_BASE_3+0x414
#define GPIOMIS3                        PL061_BASE_3+0x418
#define GPIOIC3                         PL061_BASE_3+0x41C
#define GPIOAF3                         PL061_BASE_3+0x420
#define GPIOPERIF3_ID1                  PL061_BASE_3+0xFE0
#define GPIOPERIF3_ID2                  PL061_BASE_3+0xFE4
#define GPIOPERIF3_ID3                  PL061_BASE_3+0xFE8
#define GPIOPERIF3_ID4                  PL061_BASE_3+0xFEC

/*GPIO-module 4*/
#define GPIODATA4(mask)                 PL061_BASE_4+(mask << 2)
#define GPIODIR4                        PL061_BASE_4+0x400
#define GPIOIS4                         PL061_BASE_4+0x404
#define GPIOIBE4                        PL061_BASE_4+0x408
#define GPIOIEV4                        PL061_BASE_4+0x40C
#define GPIOIE4                         PL061_BASE_4+0x410
#define GPIORIS4                        PL061_BASE_4+0x414
#define GPIOMIS4                        PL061_BASE_4+0x418
#define GPIOIC4                         PL061_BASE_4+0x41C
#define GPIOPERIF4_ID1                  PL061_BASE_4+0xFE0
#define GPIOPERIF4_ID2                  PL061_BASE_4+0xFE4
#define GPIOPERIF4_ID3                  PL061_BASE_4+0xFE8
#define GPIOPERIF4_ID4                  PL061_BASE_4+0xFEC

/*GPIO-module 5*/
#define GPIODATA5(mask)                 PL061_BASE_5+(mask << 2)
#define GPIODIR5                        PL061_BASE_5+0x400
#define GPIOIS5                         PL061_BASE_5+0x404
#define GPIOIBE5                        PL061_BASE_5+0x408
#define GPIOIEV5                        PL061_BASE_5+0x40C
#define GPIOIE5                         PL061_BASE_5+0x410
#define GPIORIS5                        PL061_BASE_5+0x414
#define GPIOMIS5                        PL061_BASE_5+0x418
#define GPIOIC5                         PL061_BASE_5+0x41C
#define GPIOPERIF5_ID1                  PL061_BASE_5+0xFE0
#define GPIOPERIF5_ID2                  PL061_BASE_5+0xFE4
#define GPIOPERIF5_ID3                  PL061_BASE_5+0xFE8
#define GPIOPERIF5_ID4                  PL061_BASE_5+0xFEC


/*GPIO-module 8*/
#define GPIODATA8(mask)                 PL061_BASE_8+(mask << 2)
#define GPIODIR8                        PL061_BASE_8+0x400
#define GPIOIS8                         PL061_BASE_8+0x404
#define GPIOIBE8                        PL061_BASE_8+0x408
#define GPIOIEV8                        PL061_BASE_8+0x40C
#define GPIOIE8                         PL061_BASE_8+0x410
#define GPIORIS8                        PL061_BASE_8+0x414
#define GPIOMIS8                        PL061_BASE_8+0x418
#define GPIOIC8                         PL061_BASE_8+0x41C
#define GPIOPERIF8_ID1                  PL061_BASE_8+0xFE0
#define GPIOPERIF8_ID2                  PL061_BASE_8+0xFE4
#define GPIOPERIF8_ID3                  PL061_BASE_8+0xFE8
#define GPIOPERIF8_ID4                  PL061_BASE_8+0xFEC

#define tmux0_tmux_en                   IO_READ(TMUX0_BASE + 0x400)
#define tmux0_tmux_0_3                  IO_READ(TMUX0_BASE + 0x404)
#define tmux0_tmux_4_7                  IO_READ(TMUX0_BASE + 0x408)
#define tmux0_direction                 IO_READ(TMUX0_BASE + 0x40C)

#define tmux1_tmux_en                   IO_READ(TMUX1_BASE + 0x400)
#define tmux1_tmux_0_3                  IO_READ(TMUX1_BASE + 0x404)
#define tmux1_tmux_4_7                  IO_READ(TMUX1_BASE + 0x408)
#define tmux1_direction                 IO_READ(TMUX1_BASE + 0x40C)

#define tmux2_tmux_en                   IO_READ(TMUX2_BASE + 0x400)
#define tmux2_tmux_0_3                  IO_READ(TMUX2_BASE + 0x404)
#define tmux2_tmux_4_7                  IO_READ(TMUX2_BASE + 0x408)
#define tmux2_direction                 IO_READ(TMUX2_BASE + 0x40C)

#define tmux3_tmux_en                   IO_READ(TMUX3_BASE + 0x400)
#define tmux3_tmux_0_3                  IO_READ(TMUX3_BASE + 0x404)
#define tmux3_tmux_4_7                  IO_READ(TMUX3_BASE + 0x408)
#define tmux3_direction                 IO_READ(TMUX3_BASE + 0x40C)

/* On GPIO-module 0*/
#define GPIO06									 0x40  // PWR_OK_N
#define GPIO07                                  0x80  // SPI_RX

/* On GPIO-module 1*/
#define GPIO08                                  0x01  // SPI_EEP_EN

/* On GPIO-module 2*/
#define GPIO17                                  0x02  // Watchdog Trigger
#define GPIO20                                  0x10  // SHTDWN_PA_N

/* On GPIO-module 3*/
#define GPIO24                                  0x01  // FANSENSE_N
#define GPIO26                                  0x04
#define GPIO27                                  0x08
#define GPIO28                                  0x10

/* On GPIO-module 4*/
#define GPIO35                                  0x08  // Bootoption
#define GPIO36                                  0x10  // Bootoption
#define GPIO37                                  0x20  // FANSENSE2_N
#define GPIO38                                  0x40  // Factory Default
#define GPIO39                                  0x80  // Bootoption

/* On GPIO-module 5*/
#define GPIO40                                  0x01  // Bootoption
#define GPIO43                                  0x08  // LED_STAT_GN
#define GPIO44                                  0x10  // LED_STAT_RD
#define GPIO45                                  0x20  // LED_PS

/* On GPIO-module 8 */
#define GPIO67                                  0x08  // Ethernet PHY
/*============================================================================*/

enum gpAdc  {
        		RF_SIG_TEMP_RF,
        		RF_SIG_TX_PWR_DET1,
        		RF_SIG_TX_PWR_DET2,
        		RF_SIG_TEMP_MB,
        		RF_SIG_TEMP_PA,
        		RF_SIG_SPARE_ADC6,
        		RF_SIG_MBADID,
        		RF_SIG_RFADID
        	};


#define AFE_BASE	0x101D7000
#define AFE_GPADC_DATA	(AFE_BASE + 0x30)
#define AFE_GPADC_CTL	(AFE_BASE + 0x34)
#define AFE_GPADC_STAT	(AFE_BASE + 0x38)

#define AFE_GPADC_CTL_RST	W5116_BIT(0)
#define AFE_GPADC_CTL_ENA	W5116_BIT(1)
#define AFE_GPADC_CTL_START	W5116_BIT(2)
/* bits 5:3 - select input channel */
/* bits 9:6 - the clock divide ratio: 0=/32, 1=/2, 2=/4, ... 15=/30 */
#define AFE_GPADC_CTL_MODEM	W5116_BIT(10)

#define AFE_GPADC_STAT_READY	W5116_BIT(0)

#define FEU_BASE	    0xA4001000
#define FEU_GPADC_SEL	(FEU_BASE + 0x118)
#define FEU_GPADC_DATA	(FEU_BASE + 0x11C)
#define FEU_GPADC_CTL	(FEU_BASE + 0x120)

#define FEU_GPADC_CTL_GPDEN	    W5116_BIT(0)
#define FEU_GPADC_CTL_GPAEN 	W5116_BIT(1)
#define FEU_GPADC_CTL_GPAMST	W5116_BIT(2)
#define FEU_GPADC_CTL_GPAMODE	W5116_BIT(3)
/* 8:4 GPPRS - clock prescalar - Fsys/2*GPPRS */
#define FEU_GPADC_CTL_GPADBG	W5116_BIT(9)
#define FEU_GPADC_CTL_GPDMST	W5116_BIT(10)

#define FEU_WARB        (FEU_BASE +  0x110 )
#define FEU_WARB_BUSY   0x01

#define	RF_ADC_0	100	/* TX_PWR_DET_2 */
#define	RF_ADC_1	101	/* TEMP_SENSE */
#define	RF_ADC_2	102	/* RFADID */
#define	RF_ADC_3	103	/* TX_PWR_DET_1 */
#define	RF_ADC_4	104	/* RX_PWR_DET_RF */
#define	RF_ADC_5	105	/* CUR_DET */
#define	RF_ADC_6	106	/* CUR_DET */
#define	RF_ADC_7	107	/* CUR_DET */

#define RF_GPIO_AFSEL 	0
#define RF_GPIO_SW_IN 	1
#define RF_GPIO_SW_OUT	2

int set_gpio(int nr, int val);
int get_gpio(int nr);

#endif
