/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : io.h
** Branch      : \main
** Version     : 4
** 
** Copyright (C) 2004,2005 by Siemens AG
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** 
**-USER-------------------------------------------------------------------------
**
** Author      : thomas.x.ritter@siemens.com
** Creation    : 13-Okt-04.19:33:29
**
** Description : Initial release
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   4 |050805|ritter     | added flash protection routines
**   3 |050628|ritter     | Added GPL license comment
**   2 |050125|ritter     | merge kernel_2.6.10 to mainline
**     |      |           | merge kernel_2.6.10 to mainline
**   1 |041013|ritter     | Initial release
**   0 |041013|ritter     | no comment
** --- |041013|ritter     | branch \main for io.h created
**-END-+------+-----------+---------------------------------------------------*/

#ifndef __ASM_ARM_ARCH_IO_H
#define __ASM_ARM_ARCH_IO_H

#ifdef __KERNEL__

#define IO_SPACE_LIMIT 0xffffffff

#define PCI_IO_VADDR      (0x0)
#define PCI_MEMORY_VADDR  (0x0)

#define __io(a)				(PCI_IO_VADDR + (a))
#define __mem_pci(a)		(a)
#define __mem_isa(a)		(PCI_MEMORY_VADDR + (unsigned long)(a))

void flash_protect(void);
void flash_unprotect(void);

/*
 * Generic virtual read/write
 */
#if 0
#define __arch_getw(a)		(*(volatile unsigned short *)(a))
#define __arch_putw(v,a)	(*(volatile unsigned short *)(a) = (v))
#endif
/*
 * Validate the pci memory address for ioremap.
 */
#define iomem_valid_addr(iomem,size)	(1)

/*
 * Convert PCI memory space to a CPU physical address
 */
#define iomem_to_phys(iomem)	(iomem)

#endif

#endif
