/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : irqs.h
** Branch      : /main
** Version     : 5
** 
** Copyright (C) 2004,2005 by Siemens AG
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** 
**-USER-------------------------------------------------------------------------
**
** Author      : thomas.x.ritter@siemens.com
** Creation    : 13-Okt-04.19:33:31
**
** Description : Initial release
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : /main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   5 |050628|ritter     | Added GPL license comment
**   4 |050125|ritter     | merge kernel_2.6.10 to mainline
**     |      |           | merge kernel_2.6.10 to mainline
**   3 |041102|ritter     | Intermediate checkin
**   2 |041021|ritter     |
**   1 |041013|ritter     | Initial release
**   0 |041013|ritter     | no comment
** --- |041013|ritter     | branch \main for irqs.h created
**-END-+------+-----------+---------------------------------------------------*/

#ifndef __wimax_irqs_h
#define __wimax_irqs_h                        1

#include <asm/arch/w5116.h>

/* for compatibility for linux */
#define NR_IRQS                 32

/* see intel datasheet ref. no. 16881 p76 */

#define WIMAX_WATCHDOG_IRQ              0
#define WIMAX_SOFTWARE_IRQ              1
#define WIMAX_COMMRX_IRQ                2
#define WIMAX_COMMTX_IRQ                3
#define WIMAX_TIMER01_IRQ               4
#define WIMAX_TIMER23_IRQ               5
#define WIMAX_UART0_IRQ                 6
#define WIMAX_CTI0_IRQ                  7
#define WIMAX_PCUMBX0_IRQ               8
#define WIMAX_PCUMBX1_IRQ               9
#define WIMAX_PCUMBX2_IRQ               10
#define WIMAX_PCUMBX3_IRQ               11
#define WIMAX_GPIO0_IRQ                 12
#define WIMAX_GPIO1_IRQ                 13
#define WIMAX_GPIO2_IRQ                 14
#define WIMAX_GPIO3_IRQ                 15
#define WIMAX_RTC_IRQ                   16
#define WIMAX_SSP_IRQ                   17
#define WIMAX_RESERVED18_IRQ            18
#define WIMAX_RESERVED19_IRQ            19
#define WIMAX_DMA_IRQ                   20
#define WIMAX_TDM_IRQ                   21
#define WIMAX_FEU_IRQ                   22
#define WIMAX_MEMERR_IRQ                23
#define WIMAX_DSPU_IRQ                  24
#define WIMAX_MDU_FIQ                   25
#define WIMAX_MDU_IRQ                   26
#define WIMAX_DSPU_FIQ                  27
#define WIMAX_QM_IRQ                    28
#define WIMAX_MAC_IRQ                   29
#define WIMAX_GPIO4_IRQ                 30
#define WIMAX_RESERVED31_IRQ            31

// needed defines for AMBA devices
#define WIMAX_SYSCONTROL_IRQ            NO_IRQ

#define INT_LVL_IGNORE         0xffff
#define INT_LVL_HIGH           0x0000
#define INT_LVL_LOW            0x00ff

#endif /* End of __irqs_h */
