/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : netstats.h
** Branch      : \main
** Version     : 5
** 
** Copyright (C) 2004,2005 by Siemens AG
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** 
**-USER-------------------------------------------------------------------------
**
** Author      : thomas.x.ritter@siemens.com
** Creation    : 22-Aug-05.13:44:39
**
** Description : Common declaration of netstats data
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   5 |050826|ritter     | Added global netstats reset
**   4 |050825|ritter     | fixe MAC table sizes
**   3 |050825|ritter     | added MAC table stats
**   2 |050822|ritter     | Initial Release
**   1 |050822|ritter     | Common declaration og netstats data
**   0 |050822|ritter     | no comment
** --- |050822|ritter     | branch \main for netstats.h created
**-END-+------+-----------+---------------------------------------------------*/
#ifndef _NETWORK_STATS_H_
#define _NETWORK_STATS_H_

#define MAX_PAYL_CHAN   16

typedef struct NetInterfaceStats
{
	unsigned short pkt;
	unsigned short error;
	unsigned int   octets;

} tNetInterfaceStats;

typedef struct NetStats
{
	unsigned int timestamp;

	struct NetInterfaceStats ethRx;
	struct NetInterfaceStats ethTx;

	struct NetInterfaceStats payloadUL[MAX_PAYL_CHAN];
	struct NetInterfaceStats payloadDL[MAX_PAYL_CHAN];

	unsigned short brEthRx;
	unsigned short brEthTx;

	unsigned short brPaylRx;
	unsigned short brPaylTx;

	unsigned short brSecmRx;
	unsigned short brSecmTx;

	unsigned short brLocalRx;
	unsigned short brLocalTx;

	unsigned short brDropped;

	unsigned short brEth2loc;
	unsigned short brEth2pay;
	unsigned short brEth2bca;
	unsigned short brPay2eth;
	unsigned short brLoc2sec;
	unsigned short brLoc2eth;

	unsigned int   brPrivate_ip;
	unsigned int   brPrivate_ip_alternate;
	unsigned int   brMgmt_ip;
	unsigned int   brPublic_ip;

    unsigned short brMacTableFree;
    unsigned short brMacTableSize;

	char brPayl_activ[2];
	char brSecm_activ[2];

	char brIsRouting;
	char brIsPhsNonStandardMode;

	char brPrivate_mac[6];

} tNetStats;

#ifdef __KERNEL__

void brFillStats(struct NetStats* );
void ethFillStats(struct NetStats* );
void skyNetFillStats(struct NetStats* );

void brResetStats(void);
void ethResetStats(void);
void skyNetResetStats(void);

#endif

#endif
