/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : system.h
** Branch      : /main
** Version     : 4
** 
** Copyright (C) 2004,2005 by Siemens AG
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
** 
**-USER-------------------------------------------------------------------------
**
** Author      : thomas.x.ritter@siemens.com
** Creation    : 13-Okt-04.19:33:39
**
** Description : Initial release
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : /main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   4 |050628|ritter     | Added GPL license comment
**   3 |050218|ritter     | add ifdefs for watchdog
**   2 |050217|ritter     | add system reset by watchdog
**   1 |041013|ritter     | Initial release
**   0 |041013|ritter     | no comment
** --- |041013|ritter     | branch \main for system.h created
**-END-+------+-----------+---------------------------------------------------*/

#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <asm/hardware.h>
#include <asm/io.h>

#ifdef CONFIG_WIMAX_WATCHDOG
void wimax_reboot(void);
#endif

/*
 * This functions used in arm/kernel/process.c
 */

static void arch_idle(void)
{
	/*
	 * This should do all the clock switching
	 * and wait for interrupt tricks
	 */
	cpu_do_idle();
}

static inline void arch_reset(char mode)
{
#ifdef CONFIG_WIMAX_WATCHDOG
    wimax_reboot();
#endif
 	/* machine should reboot ..... */
 	mdelay(5000);
 	panic("Watchdog timer reset failed!\n");
 	printk(" Jump to address 0 \n");
 	cpu_reset(0);
}

#endif
