/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : SkyMax-bridge.c
** Branch      : \main
** Version     : 2
** 
** Copyright (C) 2004,2005 by Siemens AG
** All Rights Reserved
** 
**-USER-------------------------------------------------------------------------
**
** Author      : balas.sueli@siemens.com
** Creation    : 10-Mr-05.14:36:11
**
** Description : please insert module description here
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   2 |050803|ritter     | removed references to skydata
**   2 |050803|ritter     | Remove Skydata references to be compile clean
**   1 |050310|sueli      | Initial version
**   0 |050310|sueli      | no comment
** --- |050310|sueli      | branch \main for SkyMax-bridge.c created
**-END-+------+-----------+---------------------------------------------------*/
#define __CCVERSION__     "/main/2"
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <../../skydata/skydata.h>
#include <syslog.h>

/* Forward declaration */
FindVarMethod   var_bridgeStatTable;

/*
 * bridgeStatTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
oid bridgeStatTable_variables_oid[] = { 1, 3, 6, 1, 4, 1, 8076, 1000, 3 };

/*
 * variable4 bridgeStatTable_variables:
 *   this variable defines function callbacks and type return information
 *   for the  mib section
 */
struct variable4 bridgeStatTable_variables[] =
{
/* magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

#define BRIDGESTATMACHASH       1
#define BRIDGESTATINTERFACE     2
#define BRIDGESTATMACADDRESS    3
#define BRIDGESTATEXPIRED       4
#define BRIDGESTATAGE           5
    {BRIDGESTATMACHASH,    ASN_INTEGER,   RONLY, var_bridgeStatTable, 3, {1, 1, 1}},
    {BRIDGESTATINTERFACE,  ASN_INTEGER,   RONLY, var_bridgeStatTable, 3, {1, 1, 2}},
    {BRIDGESTATMACADDRESS, ASN_OCTET_STR, RONLY, var_bridgeStatTable, 3, {1, 1, 3}},
    {BRIDGESTATEXPIRED,    ASN_INTEGER,   RONLY, var_bridgeStatTable, 3, {1, 1, 4}},
    {BRIDGESTATAGE,        ASN_INTEGER,   RONLY, var_bridgeStatTable, 3, {1, 1, 5}},
};

/*
 * (L = length of the oidsuffix)
 */


/** Initializes the bridgeStatTable module */
void init_SkyMax_Bridge(void)
{

    DEBUGMSGTL(("bridgeStatTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree
     */
    REGISTER_MIB("bridgeStatTable", bridgeStatTable_variables, variable4,
                 bridgeStatTable_variables_oid);

    /*
     * place any other initialization junk you need here
     */
}

unsigned char  *
var_bridgeStatTable(struct variable *vp, oid * name, size_t *length,
                    int exact, size_t *var_len, WriteMethod ** write_method)
{
#if 0
    SkyBridgeStats         *bridgeStats;
    static long             long_ret = 0;
    static char             mac[ 20 ];  /* "12:34:56:78:90:ab" */
    int                     index;

    /* Query the bridge statistics */
    if (skyGetData( SKY_GET_BRIDGE_STATS, &bridgeStats, 0 ) != SKY_RESULT_OK)
    {
        ERROR_MSG( "Couldn't query bridge statistics from system" );
        return NULL;
    }

    /* Check if request is valid for our simple table */
    if (header_simple_table(vp, name, length, exact, var_len, write_method, bridgeStats->numOfEntries)== MATCH_FAILED)
        return NULL;

    /* Get index to the table */
    index = name[ *length - 1 ] - 1;

    /* this is where we do the value assignments for the mib results. */
    switch (vp->magic)
    {
        case BRIDGESTATMACHASH:
            long_ret = bridgeStats->entry[ index ].mac_hash;
            break;
        case BRIDGESTATINTERFACE:
            long_ret = bridgeStats->entry[ index ].iface;
            break;
        case BRIDGESTATMACADDRESS:
            snprintf( mac, sizeof( mac ), "%.2X:%.2X:%.2X:%.2X:%.2X:%.2X",
                      bridgeStats->entry[ index ].mac_src[ 0 ],
                      bridgeStats->entry[ index ].mac_src[ 1 ],
                      bridgeStats->entry[ index ].mac_src[ 2 ],
                      bridgeStats->entry[ index ].mac_src[ 3 ],
                      bridgeStats->entry[ index ].mac_src[ 4 ],
                      bridgeStats->entry[ index ].mac_src[ 5 ]
                    );
            *var_len = strlen( mac );
            return (u_char*)mac;
            break;
        case BRIDGESTATEXPIRED:
            long_ret = bridgeStats->entry[ index ].expired;
            break;
        case BRIDGESTATAGE:
            long_ret = bridgeStats->entry[ index ].age;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char*)&long_ret;
#endif
    return 0;
}
