/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : SkyMax-eth.c
** Branch      : \main
** Version     : 2
** 
** Copyright (C) 2004,2005 by Siemens AG
** All Rights Reserved
** 
**-USER-------------------------------------------------------------------------
**
** Author      : balas.sueli@siemens.com
** Creation    : 15-febr.-05.17:09:59
**
** Description : please insert module description here
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   2 |050803|ritter     | Remove Skydata references to be compile clean
**   1 |050215|sueli      | Initial version
**   0 |050215|sueli      | no comment
** --- |050215|sueli      | branch \main for SkyMax-eth.c created
**-END-+------+-----------+---------------------------------------------------*/
#define __CCVERSION__     "/main/2"
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <../../skydata/skydata.h>

int     netsnmp_register_scalar( netsnmp_handler_registration* );
int     handle_txFrames          ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txMulticast       ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txBroadcast       ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txBytes           ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txSingleCollFrames( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txMultiCollFrames ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txLateCollFrames  ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txDeferredFrames  ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txAbortedErrors   ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txErrors          ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_txCarrierErrors   ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxFrames          ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxMulticast       ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxBroadcast       ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxBytes           ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxAlignmentErrors ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxLongFrames      ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_rxErrors          ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_collisionFrames   ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );
int     handle_sequenceErrors    ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );

int     handle_resetStatistics   ( netsnmp_mib_handler*, netsnmp_handler_registration*, netsnmp_agent_request_info*, netsnmp_request_info* );

#define RESET_STATISTICS_COMMAND    "reset"

/** Initializes the SkyMax-eth module */
void
init_SkyMax_Eth(void)
{
    /* Static OIDs */
    static oid      txFrames_oid[]           = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 1  };
    static oid      txMulticast_oid[]        = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 2  };
    static oid      txBroadcast_oid[]        = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 3  };
    static oid      txBytes_oid[]            = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 4  };
    static oid      txSingleCollFrames_oid[] = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 5  };
    static oid      txMultiCollFrames_oid[]  = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 6  };
    static oid      txLateCollFrames_oid[]   = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 7  };
    static oid      txDeferredFrames_oid[]   = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 8  };
    static oid      txAbortedErrors_oid[]    = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 9  };
    static oid      txErrors_oid[]           = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 10 };
    static oid      txCarrierErrors_oid[]    = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 11 };
    static oid      rxFrames_oid[]           = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 12 };
    static oid      rxMulticast_oid[]        = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 13 };
    static oid      rxBroadcast_oid[]        = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 14 };
    static oid      rxBytes_oid[]            = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 15 };
    static oid      rxAlignmentErrors_oid[]  = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 16 };
    static oid      rxLongFrames_oid[]       = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 17 };
    static oid      rxErrors_oid[]           = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 18 };
    static oid      collisionFrames_oid[]    = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 19 };
    static oid      sequenceErrors_oid[]     = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 20 };

    static oid      resetStatistics_oid[]    = { 1, 3, 6, 1, 4, 1, 8076, 1000, 1, 100 };

    DEBUGMSGTL(("SkyMax-eth", "Initializing\n"));

    /* Register each variable */
    netsnmp_register_scalar(netsnmp_create_handler_registration("txFrames",           handle_txFrames,           txFrames_oid          , OID_LENGTH(txFrames_oid          ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txMulticast",        handle_txMulticast,        txMulticast_oid       , OID_LENGTH(txMulticast_oid       ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txBroadcast",        handle_txBroadcast,        txBroadcast_oid       , OID_LENGTH(txBroadcast_oid       ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txBytes",            handle_txBytes,            txBytes_oid           , OID_LENGTH(txBytes_oid           ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txSingleCollFrames", handle_txSingleCollFrames, txSingleCollFrames_oid, OID_LENGTH(txSingleCollFrames_oid), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txMultiCollFrames",  handle_txMultiCollFrames,  txMultiCollFrames_oid , OID_LENGTH(txMultiCollFrames_oid ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txLateCollFrames",   handle_txLateCollFrames,   txLateCollFrames_oid  , OID_LENGTH(txLateCollFrames_oid  ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txDeferredFrames",   handle_txDeferredFrames,   txDeferredFrames_oid  , OID_LENGTH(txDeferredFrames_oid  ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txAbortedErrors",    handle_txAbortedErrors,    txAbortedErrors_oid   , OID_LENGTH(txAbortedErrors_oid   ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txErrors",           handle_txErrors,           txErrors_oid          , OID_LENGTH(txErrors_oid          ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("txCarrierErrors",    handle_txCarrierErrors,    txCarrierErrors_oid   , OID_LENGTH(txCarrierErrors_oid   ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxFrames",           handle_rxFrames,           rxFrames_oid          , OID_LENGTH(rxFrames_oid          ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxMulticast",        handle_rxMulticast,        rxMulticast_oid       , OID_LENGTH(rxMulticast_oid       ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxBroadcast",        handle_rxBroadcast,        rxBroadcast_oid       , OID_LENGTH(rxBroadcast_oid       ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxBytes",            handle_rxBytes,            rxBytes_oid           , OID_LENGTH(rxBytes_oid           ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxAlignmentErrors",  handle_rxAlignmentErrors,  rxAlignmentErrors_oid , OID_LENGTH(rxAlignmentErrors_oid ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxLongFrames",       handle_rxLongFrames,       rxLongFrames_oid      , OID_LENGTH(rxLongFrames_oid      ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("rxErrors",           handle_rxErrors,           rxErrors_oid          , OID_LENGTH(rxErrors_oid          ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("CollisionFrames",    handle_collisionFrames,    collisionFrames_oid   , OID_LENGTH(collisionFrames_oid   ), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration("SequenceErrors",     handle_sequenceErrors,     sequenceErrors_oid    , OID_LENGTH(sequenceErrors_oid    ), HANDLER_CAN_RONLY));

    netsnmp_register_scalar(netsnmp_create_handler_registration("resetStatistics",    handle_resetStatistics,    resetStatistics_oid   , OID_LENGTH(resetStatistics_oid   ), HANDLER_CAN_RWRITE));
}

int handle_txFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txFrames,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txMulticast( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txMulticastFramesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txMulticast\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txBroadcast( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txBroadcastFramesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txBroadcast\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txBytes( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txBytesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txBytes\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txSingleCollFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txSingleCollisionFrames,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txSingleCollFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txMultiCollFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txMultipleCollisionFrames,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txMultiCollFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txLateCollFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txLateCollisions,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txLateCollFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txDeferredFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txFramesWithDeferredTransmissions,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txDeferredFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txAbortedErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txFramesAbortedDueToXSColls,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txAbortedErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txFramesLostDueToIntMACError,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_txCarrierErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->txCarrierSenseErrors,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_txCarrierErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxFramesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxMulticast( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxMulticastFramesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxMulticast\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxBroadcast( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxBroadcastFramesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxBroadcast\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxBytes( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxBytesOK,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxBytes\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxAlignmentErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxAlignmentErrors,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxAlignmentErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxLongFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxFrameTooLongErrors,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxLongFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_rxErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->rxFramesLostDueToIntMACError,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_rxErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_collisionFrames( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->collisionFrames,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_collisionFrames\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_sequenceErrors( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    SkyEthStats    *ethStats;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            skyGetData( SKY_GET_ETH_STATS, &ethStats, sizeof( ethStats ) );
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *)&ethStats->frameCheckSequenceErrors,
                                      sizeof( size_t )
                                    );
            break;
        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_sequenceErrors\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}

int handle_resetStatistics( netsnmp_mib_handler *handler, netsnmp_handler_registration *reginfo, netsnmp_agent_request_info *reqinfo, netsnmp_request_info *requests )
{
#if 0
    static char    *myString = RESET_STATISTICS_COMMAND;
    switch (reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value( requests->requestvb, ASN_OCTET_STR,
                                      (u_char *)myString,
                                      strlen( myString )
                                    );
            break;

            /* SET REQUEST */
        case MODE_SET_RESERVE1:
            /* The only command we accept is 'reset' */
            if (strcmp( requests->requestvb->val.string, RESET_STATISTICS_COMMAND ))
            {
                /* Unknown command - indicate error */
                netsnmp_set_request_error( reqinfo, requests, SNMP_ERR_WRONGVALUE );
            }
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:
            /* perform the value change here */
            skyAction( SKY_ACTION_RESET_ETH_STATS, NULL );
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_resetStatistics\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }
#endif
    return SNMP_ERR_NOERROR;
}
