/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : SkyMax-shm.c
** Branch      : \main
** Version     : 2
** 
** Copyright (C) 2004,2005 by Siemens AG
** All Rights Reserved
** 
**-USER-------------------------------------------------------------------------
**
** Author      : balas.sueli@siemens.at
** Creation    : 24-febr.-05.13:21:14
**
** Description : please insert module description here
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   2 |050803|ritter     | Remove Skydata references to be compile clean
**   1 |050224|sueli      | Initial creation
**   0 |050224|sueli      | no comment
** --- |050224|sueli      | branch \main for SkyMax-shm.c created
**-END-+------+-----------+---------------------------------------------------*/
#define __CCVERSION__     "/main/2"
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.4 2004/07/28 08:04:58 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <../../skydata/skydata.h>

#define SHM_STAT_GLOBAL_TABLE_SIZE       3

/* Forward declaration */
FindVarMethod   var_shmStatChannelTable;
FindVarMethod   var_shmStatGlobalTable;

/*
 * shmStatTable_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
oid shmStatTable_variables_oid[] = { 1, 3, 6, 1, 4, 1, 8076, 1000, 2 };

/*
 * variable4 shmStatTable_variables:
 *   this variable defines function callbacks and type return information
 *   for the  mib section
 */
struct variable4 shmStatTable_variables[] =
{
/* magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

#define SHMSTATCHANNEL      1
#define SHMSTATSENTDATA     2
#define SHMSTATRECVDATA     3
#define SHMSTATALLOCREQ     4
#define SHMSTATFREEREQ      5
#define SHMSTATACK          6
#define SHMSTATNAK          7
#define SHMSTATRECVDROPPED  8
#define SHMSTATSENTDROPPED  9
    {SHMSTATCHANNEL,     ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 1}},
    {SHMSTATSENTDATA,    ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 2}},
    {SHMSTATRECVDATA,    ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 3}},
    {SHMSTATALLOCREQ,    ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 4}},
    {SHMSTATFREEREQ,     ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 5}},
    {SHMSTATACK,         ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 6}},
    {SHMSTATNAK,         ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 7}},
    {SHMSTATRECVDROPPED, ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 8}},
    {SHMSTATSENTDROPPED, ASN_INTEGER, RONLY, var_shmStatChannelTable, 3, {1, 1, 9}},

#define SHMSTATCOUNTTYPE     1
#define SHMSTATCOUNTZEROSIZE 2
#define SHMSTATCOUNTALLOC    3
#define SHMSTATCOUNTRELEASE  4
    {SHMSTATCOUNTTYPE,     ASN_OCTET_STR, RONLY, var_shmStatGlobalTable, 3, {2, 1, 1}},
    {SHMSTATCOUNTZEROSIZE, ASN_INTEGER,   RONLY, var_shmStatGlobalTable, 3, {2, 1, 2}},
    {SHMSTATCOUNTALLOC,    ASN_INTEGER,   RONLY, var_shmStatGlobalTable, 3, {2, 1, 3}},
    {SHMSTATCOUNTRELEASE,  ASN_INTEGER,   RONLY, var_shmStatGlobalTable, 3, {2, 1, 4}},
};

/*
 * (L = length of the oidsuffix)
 */


/** Initializes the shmStatTable module */
void init_SkyMax_Shm(void)
{
#if 0
    DEBUGMSGTL(("shmStatTable", "Initializing\n"));

    /*
     * register ourselves with the agent to handle our mib tree
     */
    REGISTER_MIB("shmStatTable", shmStatTable_variables, variable4,
                 shmStatTable_variables_oid);

    /*
     * place any other initialization junk you need here
     */
#endif
}

unsigned char  *
var_shmStatChannelTable(struct variable *vp, oid * name, size_t *length,
                        int exact, size_t *var_len, WriteMethod ** write_method)
{
#if 0
    SkyShmStats            *shmStats;
    static long             long_ret = 0;
    int                     index;

    /* Query the shm statistics */
   if (skyGetData( SKY_GET_SHM_STATS, &shmStats, 0 ) != SKY_RESULT_OK)
    {
        ERROR_MSG( "Couldn't query shm statistics from system" );
        return NULL;
    }

    /* Check if request is valid for our simple table */
    if (header_simple_table(vp, name, length, exact, var_len, write_method, SKY_SHM_STATS_CHANNELS)== MATCH_FAILED)
        return NULL;

    /* Get index to the table */
    index = name[ *length - 1 ] - 1;

    /* this is where we do the value assignments for the mib results. */
    switch (vp->magic)
    {
        case SHMSTATCHANNEL:
            long_ret = shmStats->channel[ index ].channel;
            break;
        case SHMSTATSENTDATA:
            long_ret = shmStats->channel[ index ].sentData;
            break;
        case SHMSTATRECVDATA:
            long_ret = shmStats->channel[ index ].recvData;
            break;
        case SHMSTATALLOCREQ:
            long_ret = shmStats->channel[ index ].allocReq;
            break;
        case SHMSTATFREEREQ:
            long_ret = shmStats->channel[ index ].freeReq;
            break;
        case SHMSTATACK:
            long_ret = shmStats->channel[ index ].ack;
            break;
        case SHMSTATNAK:
            long_ret = shmStats->channel[ index ].nak;
            break;
        case SHMSTATRECVDROPPED:
            long_ret = shmStats->channel[ index ].recvDropped;
            break;
        case SHMSTATSENTDROPPED:
            long_ret = shmStats->channel[ index ].sentDropped;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char*)&long_ret;
#endif
	return 0;
}

unsigned char  *
var_shmStatGlobalTable(struct variable *vp, oid * name, size_t *length,
                       int exact, size_t *var_len, WriteMethod ** write_method)
{
#if 0
    SkyShmStats            *shmStats;
    static long             long_ret = 0;
    static char             str_ret[ 32 ];
    int                     index;

    /* Query the shm statistics */
   if (skyGetData( SKY_GET_SHM_STATS, &shmStats, 0 ) != SKY_RESULT_OK)
    {
        ERROR_MSG( "Couldn't query shm statistics from system" );
        return NULL;
    }

    /* Check if request is valid for our simple table */
    if (header_simple_table(vp, name, length, exact, var_len, write_method, SHM_STAT_GLOBAL_TABLE_SIZE)== MATCH_FAILED)
        return NULL;

    /* Get index to the table */
    index = name[ *length - 1 ] - 1;

    /* this is where we do the value assignments for the mib results. */
    switch (vp->magic)
    {
        case SHMSTATCOUNTTYPE:
            strncpy( str_ret, shmStats->common[ index ].type, sizeof( str_ret ) );
            *var_len = strlen( str_ret );
            return (u_char*)str_ret;
        case SHMSTATCOUNTZEROSIZE:
            long_ret = shmStats->common[ index ].cntAlloc;
            break;
        case SHMSTATCOUNTALLOC:
            long_ret = shmStats->common[ index ].cntRelease;
            break;
        case SHMSTATCOUNTRELEASE:
            long_ret = shmStats->common[ index ].cntActive;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char*)&long_ret;
#endif
	return 0;
}
