/*-MH---------------------------------------------------------------------------
** Project     : SkyMAX
** Filename    : SkyMax.c
** Branch      : \main
** Version     : 5
** 
** Copyright (C) 2004,2005 by Siemens AG
** All Rights Reserved
** 
**-USER-------------------------------------------------------------------------
**
** Author      : balas.sueli@siemens.com
** Creation    : 09-febr.-05.18:33:12
**
** Description : please insert module description here
**
**-END------------------------------------------------------------------------*/
/*-HOC--------------------------------------------------------------------------
** 
** Branch : \main
** 
**-----+------+-----------+-----------------------------------------------------
** Ver |Date  |Name       | Text
**-USER+------+-----------+-----------------------------------------------------
**   5 |050803|ritter     | removed references to skydata
**   5 |050803|ritter     | Remove Skydata references to be compile clean
**   3 |050223|sueli      | Demo variables shifted in MIB tree
**   2 |050215|sueli      | Added ethernet statistics
**   1 |050209|sueli      | Initial version
**   0 |050209|sueli      | no comment
** --- |050209|sueli      | branch \main for SkyMax.c created
**-END-+------+-----------+---------------------------------------------------*/
#define __CCVERSION__     "/main/5"
/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.scalar.conf,v 1.8 2004/10/14 12:57:34 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/scalar.h>
#include <../../skydata/skydata.h>
#include "SkyMax.h"

/* Forward declarations */
void init_SkyMax_Eth( void );
void init_SkyMax_Shm( void );
void init_SkyMax_Bridge( void );

/** Initializes the SkyMax module */
void
init_SkyMax(void)
{
    /* Static OIDs */
    static oid      arm0OS_oid[]      = { 1, 3, 6, 1, 4, 1, 8076, 1000, 10, 1 };
    static oid      arm0Integer_oid[] = { 1, 3, 6, 1, 4, 1, 8076, 1000, 10, 2 };
    static oid      arm1OS_oid[]      = { 1, 3, 6, 1, 4, 1, 8076, 1000, 11, 1 };
    static oid      arm1Integer_oid[] = { 1, 3, 6, 1, 4, 1, 8076, 1000, 11, 2 };

    DEBUGMSGTL(("SkyMax", "Initializing\n"));

    /* Register each variable */
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("arm0OS", handle_arm0OS, arm0OS_oid,
                             OID_LENGTH(arm0OS_oid), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("arm0Integer", handle_arm0Integer,
                             arm0Integer_oid, OID_LENGTH(arm0Integer_oid),
                             HANDLER_CAN_RWRITE));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("arm1OS", handle_arm1OS, arm1OS_oid,
                             OID_LENGTH(arm1OS_oid), HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("arm1Integer", handle_arm1Integer,
                             arm1Integer_oid, OID_LENGTH(arm1Integer_oid),
                             HANDLER_CAN_RWRITE));

    /* Initialize MIB variables implemented in other c modules */
    init_SkyMax_Eth();
    init_SkyMax_Shm();
    init_SkyMax_Bridge();

    snmp_log( LOG_INFO, "SkyMax MIB initialized.\n" );
}

int
handle_arm0OS(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{
    static char    *myString = "uCLinux-2.6.10";

    /* We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us. */

    /* a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. */

    switch (reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value( requests->requestvb, ASN_OCTET_STR,
                                      (u_char *) myString,
                                      strlen( myString )
                                    );
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_arm0OS\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_arm0Integer(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    static int      myInteger = 500;
    /* We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us. */

    /* a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. */

    switch (reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *) &myInteger,
                                      sizeof( myInteger )
                                    );
            break;

            /* SET REQUEST */
        case MODE_SET_RESERVE1:
            /* Check incoming data in requests->requestvb->val.XXX for failures,
             * like an incorrect type or an illegal value or something else */
            if (    *requests->requestvb->val.integer < 0
                 || *requests->requestvb->val.integer > 1000
               )
            {
                netsnmp_set_request_error( reqinfo, requests, SNMP_ERR_WRONGVALUE );
            }
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:
            /* perform the value change here */
            myInteger = *requests->requestvb->val.integer;
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_arm0Integer\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_arm1OS(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests)
{
    static char    *myString = "uc OS II";

    /* We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us. */

    /* a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. */

    switch (reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value( requests->requestvb, ASN_OCTET_STR,
                                      (u_char *) myString,
                                      strlen( myString )
                                    );
            break;


        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_arm1OS\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_arm1Integer(netsnmp_mib_handler *handler,
                   netsnmp_handler_registration *reginfo,
                   netsnmp_agent_request_info *reqinfo,
                   netsnmp_request_info *requests)
{
    static int      myInteger = -10;
    /* We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us. */

    /* a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. */

    switch (reqinfo->mode)
    {
        case MODE_GET:
            snmp_set_var_typed_value( requests->requestvb, ASN_INTEGER,
                                      (u_char *) &myInteger,
                                      sizeof( myInteger )
                                    );
            break;

            /* SET REQUEST */
        case MODE_SET_RESERVE1:
            /* Check incoming data in requests->requestvb->val.XXX for failures,
             * like an incorrect type or an illegal value or something else */
            if (    *requests->requestvb->val.integer < -100
                 || *requests->requestvb->val.integer >  100
               )
            {
                netsnmp_set_request_error( reqinfo, requests, SNMP_ERR_WRONGVALUE );
            }
            break;

        case MODE_SET_RESERVE2:
            break;

        case MODE_SET_FREE:
            break;

        case MODE_SET_ACTION:
            /* perform the value change here */
            myInteger = *requests->requestvb->val.integer;
            break;

        case MODE_SET_COMMIT:
            break;

        case MODE_SET_UNDO:
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_arm1Integer\n", reqinfo->mode);
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
