//-MH---------------------------------------------------------------------------
// Project     : SkyMAX
// Filename    : service.cpp
// Branch      : \main
// Version     : 1
// 
// Copyright (C) 2004,2005 by Siemens AG
// All Rights Reserved
// 
//-USER-------------------------------------------------------------------------
// 
// Author      : thomas.x.ritter@siemens.com
// Creation    : 26-Jul-05.19:56:33
// 
// Description : uClinux super daemon
// 
//-END--------------------------------------------------------------------------
//-HOC--------------------------------------------------------------------------
// 
// Branch : \main
// 
//-----+------+-----------+-----------------------------------------------------
// Ver |Date  |Name       | Text
//-USER+------+-----------+-----------------------------------------------------
//   1 |050726|ritter     | uClinux super daemon
//   0 |050726|ritter     | no comment
// --- |050726|ritter     | branch \main for service.cpp created
//-END-+------+-----------+-----------------------------------------------------
#define __CCVERSION__     "/main/1"
#include "ucbox.h"
#include "stringTokenizer.h"
#include "file.h"

void Service::writePidFile()
{
    char buf[10], path[80];

    sprintf(buf, "%d", getpid());
    sprintf(path, "/tmp/var/run/%s.pid", m_Name);
    if (File::writeFile(buf, path))
    {
        LOG("%s: running pid %d", m_Name, getpid());
    }
    else
    {
        WRN("%s: Cannot write pid file: %s", m_Name, strerror(errno));
    }
}

char*  myArgs[MAX_ARGS + 1];
char   myPath[MAXPATHLEN];

int Service::start(int argc, char* argv[])
{
    int myArgCount = 0;

    // arg 0 is program name
    strcpy(myPath, m_Path);
    strcat(myPath, m_Name);
    myArgs[myArgCount++] = myPath;

    for (int i = 3; i < argc; ++i)
    {
        myArgs[myArgCount++] = argv[i];
        // check maximimum
        if (myArgCount >= MAX_ARGS) break;
    }

    switch (vfork())
    {
    case 0:
        /* child */
        execv(myPath, myArgs);
        fprintf(stderr, "ucbox - execv %s: %s\n", myPath, strerror(errno));
        _exit(127);

    case -1:           /* error */
        fprintf(stderr, "vfork: %s", strerror(errno));
        return -1;
    }

    return 0;
}

int Service::stop()
{
    String pid;
    char path[MAXPATHLEN];

    sprintf(path, "/tmp/var/run/%s.pid", m_Name);

    if (File::readFile(pid, path))
    {
        int pidNo = pid.toInteger();
        if (pidNo > 0)
        {
            kill(pidNo, SIGTERM);
            unlink(path);

            LOG("%s: stopped pid %d", m_Name, pidNo);
        }
    }
    return 0;
}
