//-MH---------------------------------------------------------------------------
// Project     : SkyMAX
// Filename    : ucbox.cpp
// Branch      : \main
// Version     : 3 (checkedout)
// 
// Copyright (C) 2004,2005 by Siemens AG
// All Rights Reserved
// 
//-USER-------------------------------------------------------------------------
//
// Author      : thomas.x.ritter@siemens.com
// Creation    : 26-Jul-05.19:56:37
//
// Description : uClinux super daemon
//
//-END--------------------------------------------------------------------------
//-HOC--------------------------------------------------------------------------
// 
// Branch : \main
// 
//-----+------+-----------+-----------------------------------------------------
// Ver |Date  |Name       | Text
//-USER+------+-----------+-----------------------------------------------------
// ??? |yymmdd|strauss    |  
//   3 |050803|ritter     | Removed ftp from ucbox
//   2 |050728|ritter     | [BL016] added pppd to ucbox
//   1 |050726|ritter     | uClinux super daemon
//   0 |050726|ritter     | no comment
// --- |050726|ritter     | branch \main for ucbox.cpp created
//-END-+------+-----------+-----------------------------------------------------
#define __CCVERSION__     "checked-out"
#include "ucbox.h"
#include <sys/wait.h>

#define MAX_SERVICE     16

extern "C"
{
    int dnsmasq_main (int argc, char *argv[]);
    int dumpleases_main(int argc, char *argv[]);
    int udhcpd_main(int argc, char *argv[]);
    int udhcpc_main(int argc, char *argv[]);
    int pppd_main(int argc, char *argv[]);
    int knockd_main(int argc, char *argv[]);
};

static Service  theServiceData[] =
{
    { "/usr/sbin/", "dnsmasq",     dnsmasq_main     },
    { "/usr/bin/",  "dumpleases",  dumpleases_main  },
    { "/usr/sbin/", "udhcpd",      udhcpd_main      },
    { "/usr/bin/",  "udhcpc",      udhcpc_main      },
    { "/usr/sbin/", "pppd",        pppd_main        },
    { "/usr/sbin/", "knockd",      knockd_main      },
};

static const size_t   theServiceCount = 6;

static Service* getService(const char* name)
{
    for (size_t i = 0; i < theServiceCount; ++i)
    {
        if (0 == strncmp(theServiceData[i].m_Name, name, strlen(theServiceData[i].m_Name)))
        {
            return &theServiceData[i];
        }
    }
    return 0;
}

static void usage()
{
    printf("ucbox usage: uCLinux super damon\n");
    printf("\tstart service params\n");
    printf("\tstop  service\n");
    printf("Services:\n");

    for (size_t i = 0; i < theServiceCount; ++i)
    {
        if (i != 0) printf(", ");
        printf(theServiceData[i].m_Name);
    }
    printf("\n");
}

int main(int argc, char* argv[])
{
    char progname[MAXPATHLEN];

    strcpy(progname, basename(argv[0]));
    log_open(LOG_LOCAL2, "ucbox");

    Service* myService = getService(progname);
    if (myService)
    {
        myService->writePidFile();
        return (*myService->m_Entry)(argc, argv);
    }
    else
    {
        if (argc > 2)
        {
            if (0 == strcmp(argv[1], "start"))
            {
                Service* myService = getService(argv[2]);
                if (myService)
                {
                    return myService->start(argc, argv);
                }
            }

            if (0 == strcmp(argv[1], "stop"))
            {
                Service* myService = getService(argv[2]);
                if (myService)
                {
                    return myService->stop();
                }
            }
            fprintf(stderr, "ucbox: no such service: %s\n", argv[2]);
        }
    }

    usage();
    return -1;
}
